// playMP3Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "playMP3.h"
#include "playMP3Dlg.h"

#include "player/PlayerMP3.h"
#include <direct.h>                                         // _getcwd
#include <math.h>                                           // log

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayMP3Dlg dialog

CPlayMP3Dlg::CPlayMP3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayMP3Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlayMP3Dlg)
	m_strTitle = _T("no song currently loaded; click 'Load' button");
	m_strVolume = _T("100");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

  m_pPlayerMP3 = NULL;
}


CPlayMP3Dlg::~CPlayMP3Dlg()
{
  delete m_pPlayerMP3;
  CoUninitialize();
}

void CPlayMP3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlayMP3Dlg)
	DDX_Control(pDX, IDC_SPINVOLUME, m_spinVolume);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDC_REWIND, m_btnRewind);
	DDX_Control(pDX, IDC_PLAY, m_btnPlay);
	DDX_Control(pDX, IDC_PAUSE, m_btnPause);
	DDX_Text(pDX, IDC_TITLE, m_strTitle);
	DDX_Text(pDX, IDC_VOLUME, m_strVolume);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPlayMP3Dlg, CDialog)
	//{{AFX_MSG_MAP(CPlayMP3Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_REWIND, OnRewind)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINVOLUME, OnDeltaposSpinvolume)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayMP3Dlg message handlers

BOOL CPlayMP3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  CoInitialize(NULL);
  m_pPlayerMP3 = new CPlayerMP3;
  if(!m_pPlayerMP3) return FALSE;                           // init failed
  UpdateButtons();

  m_spinVolume.SetRange(0,100);
  m_spinVolume.SetPos(100);

  m_nTimer = SetTimer(1,1000,NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

//

void CPlayMP3Dlg::OnDestroy() 
{
  KillTimer(m_nTimer);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlayMP3Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlayMP3Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//
//

void CPlayMP3Dlg::OnLoad() 
{
  char szBuffer[_MAX_PATH];                                 // get the current working directory
  _getcwd(szBuffer,_MAX_PATH);
   
  // open file dialog

	CFileDialog cfileD(TRUE,"MP3",NULL,/*OFN_NOCHANGEDIR*/0,"Music Files (*.MP3)|*.MP3||");
  cfileD.m_ofn.lpstrInitialDir = szBuffer;                  // initial dir
  if(cfileD.DoModal() != IDOK) return;                      // cancel

  if(CPlayerMP3::_OK_ == m_pPlayerMP3->hrLoad(LPCTSTR(cfileD.GetPathName())))
  {
    OnPlay();
    m_strTitle = cfileD.GetFileName();
    m_spinVolume.SetPos(100);
    m_strVolume = "100";
    UpdateData(FALSE);
  }

  else
  {
    MessageBox("the file does not exist, is not a valid MP3, or DirectSound is used by another application",
               "error initializing file replay",MB_ICONEXCLAMATION | MB_OK);
  	m_strTitle = _T("no song currently loaded; click 'Load' button");
    UpdateData(FALSE);
    UpdateButtons();
  }
}

//

void CPlayMP3Dlg::OnPlay() 
{
  m_pPlayerMP3->hrPlay();
  UpdateButtons();
}

void CPlayMP3Dlg::OnPause() 
{
  m_pPlayerMP3->hrPause();
  UpdateButtons();
}

void CPlayMP3Dlg::OnStop() 
{
  m_pPlayerMP3->hrStop();
  UpdateButtons();
}

void CPlayMP3Dlg::OnRewind() 
{
  m_pPlayerMP3->hrRewind();
  UpdateButtons();
}

//

void CPlayMP3Dlg::UpdateButtons()
{
  m_btnPlay.EnableWindow(m_pPlayerMP3->boCanPlay());
  m_btnPlay.SetCheck    (m_pPlayerMP3->boIsPlaying());

  m_btnPause.EnableWindow(m_pPlayerMP3->boCanPause());
  m_btnPause.SetCheck    (m_pPlayerMP3->boIsPaused());

  m_btnStop  .EnableWindow(m_pPlayerMP3->boCanStop());
  m_btnRewind.EnableWindow(m_pPlayerMP3->boIsInitialized());
}

//

void CPlayMP3Dlg::OnDeltaposSpinvolume(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	*pResult = 0;

  int iNew = pNMUpDown->iPos+pNMUpDown->iDelta;
  if(iNew <   0) iNew =   0;
  if(iNew > 100) iNew = 100;

  long lVol = -10000;                                       // silence
  if(iNew > 0)
    {
    float fPercent = (float)iNew*0.01f;
    float fLog     = (float)log(fPercent);
    lVol = long(fLog*1000.f);
    }

  m_pPlayerMP3->hrSetVolume(lVol);

  m_strVolume.Format("%d",iNew);
  UpdateData(FALSE);
}

// wait for end of stream

void CPlayMP3Dlg::OnTimer(UINT nIDEvent) 
{
  if(m_pPlayerMP3->boCompleted())
    {
    OnStop();
    OnRewind();
    }
	
	CDialog::OnTimer(nIDEvent);
}
